var AVAILABILITY_TOKEN = Math.floor(Math.random() * 212345);
var SCHEDULED_TOKEN = Math.floor(Math.random() * 212345);
var action = 'Save';
var vs_id = "";
var UPDATE_AVAILABILITY_ID = 0;
var UPDATE_SCHEDULED_ID = 0;

$(document).ready(function () {
    var tableAttachment = $('#tblScheduleAttachment').DataTable({
        responsive: false,
        "scrollX": true,
        "pageLength": 100,
        "order": [],
        "columns": [
            { "data": "file" },
            { "data": "view" },
            { "data": "download" },
            { "data": "delete" },

        ],
        columnDefs: [
            { width: 80, targets: 1 },
            { width: 80, targets: 2 },
            { width: 80, targets: 3 },
        ],
    });

    $('#attachmnet_schedule_token').val(SCHEDULED_TOKEN);

    $('#btnScheduleAttachment').on('click', function () {
        $('#attachmentScheduledModal').modal('show');
    });

    if (window.location.search.length > 0) {
        var sPageURL = window.location.search.substring(1);
        var param = sPageURL.split("?");
        vs_id = param[0].split("=")[1].split("&")[0];
        action = param[0].split("=")[2].split("&")[0];

        if (action == "edit") {
            $("#btnScheduleAction").text("Update");
            allVesselScheduleAttachment(vs_id);
            getRoData(vs_id);
        } else if (action == "view") {
            getRoData(vs_id);
            allVesselScheduleAttachment(vs_id);
            $("#btnScheduleAction").hide();
            $("#btnScheduleAttachment").hide();
        }
    }

    $("#btnScheduleAction").on("click", function () {
        if ($(this).text() == "Save") {
            saveSchedule();
        } else {
            updateSchedule(vs_id);
        }
    });

    $('#shipment').on('change', function () {
        getCustomerOrderData(this.value);
    });

    getShipmentData();
    getShippingAgentData();
});



Dropzone.options.scheduledDropzone = {
    dictDefaultMessage: 'Drop file here or click to upload!!!!!!!!',
    method: 'POST',
    url: '/sd/blInstructionController/uploadScheduleAttachment',
    params: {
        description: "abc"
    },
    addRemoveLinks: true,
    uploadMultiple: false,
    clickable: true,

    init: function () {
        var myDropzone = this;

        // Here's the change from enyo's tutorial...

        $("#submit-all").click(function (e) {
            e.preventDefault();
            e.stopPropagation();
            myDropzone.processQueue();
        }
        );

        this.on("sending", function (file, xhr, formData) {

            if (!checkStringLength($('#txtScheduleDescription').val(), 500)) {
                showWarningMessage('Data too long for "Description".')
                return;
            }

            // Will sendthe filesize along with the file as POST data.

            formData.append("foo", $('#txtScheduleDescription').val());

        });

        this.on("success", function (file, responseText) {
            var responseText = file.id // or however you would point to your assigned file ID here;
            console.log(responseText); // console should show the ID you pointed to
            // do stuff with file.id ...
            //alert();
        });

        this.on("addedfile", file => {
            console.log(file);
        });

        this.on("complete", function (file) {
            allVesselScheduleAttachment(UPDATE_SCHEDULED_ID);
            console.log(file);
        });

        this.on("errormultiple", function (files, response) {

        });

        clearDropzone = function () {
            myDropzone.removeAllFiles(true);
        };
    }
};




function vessel_scheduled(id, status) {

    SCHEDULED_TOKEN = Math.floor(Math.random() * 212345);
    $('#attachmnet_schedule_token').val(SCHEDULED_TOKEN);
    var table = $('#tblScheduleAttachment').DataTable();
    table.clear();
    table.rows.add([]).draw();
    getScheduleHeader(id);
}



function allVesselScheduleAttachment(id) {
    $.ajax({
        type: "GET",
        url: "/sd/blInstructionController/allScheduleAttachment/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                var data = [];
                for (var i = 0; i < result.length; i++) {
                    var path = "'" + result[i].file_path + "'";
                    var id = "'" + result[i].sd_bl_instruction_attachment_id + "'";
                    data.push({
                        "file": result[i].description,
                        "view": '<button type= "button" class="btn btn-primary" onclick="viewScheduleAttachment(' + path + ');"><i class="fa fa-eye" aria-hidden="true"></i></button> ',
                        "download": '<button type= "button" class="btn btn-success" onclick="downloadScheduleAttachment(' + path + ');"><i class="fa fa-download" aria-hidden="true"></i></button> ',
                        "delete": '<button type= "button" class="btn btn-danger" onclick="deleteScheduleAttachment(' + id + ');"><i class="fa fa-trash" aria-hidden="true"></i></button> ',
                    });
                }
                var table = $('#tblScheduleAttachment').DataTable();
                table.clear();
                table.rows.add(data).draw();
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}



function viewScheduleAttachment(file) {
    window.open(file);

}



function downloadScheduleAttachment(file) {
    var link = document.createElement("a");
    link.download = file;
    link.href = file;
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
    delete link;
}


function deleteScheduleAttachment(id) {

    showAlert("Are You Sure?", id);
}

function getRoData(id) {
    $.ajax({
        type: "GET",
        url: "/sd/blInstructionController/getRoData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            // progress(true);
        },
        success: function (response) {
            console.log(response);
            var res = response.data.result;

            $("#shipment").val(res.shipment_id);
            $("#shipping_agent").val(res.shipping_agent_id);
            $("#txtCustomerOrderNo").val(res.customer_order_id);
            $("#txtFactoryPo").val(res.factory_po) ;
            $("#txtAdditionalNote").val(res.note) ;

            // var request_data = res.request_data;
            // for (var i = 0; i < request_data.length; i++) {
            // }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {
            // progress(false);
        },
    });
}


function getScheduleHeader(id) {

    $.ajax({
        type: "GET",
        url: "/sd/customerOrderList/getScheduleHeader/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            resetScheduleModal();
        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;

                var table = $('#tblScheduleAttachment').DataTable();
                table.clear();
                $('#hidScheduleOrderId').val(id);
                $('#lblScheduleFactoryOrder').text(result.factory_po_num);
                $('#lblScheduleDestination').text(result.address);
                $('#lblScheduleCustomerPo').text(result.purchase_order);
                $('#lblScheduleETA').text(result.delivery_date);
                var currency = result.currency;
                $('#cmbScheduleCurrency').empty();
                for (var i = 0; i < currency.length; i++) {

                    $('#cmbScheduleCurrency').append('<option value="' + currency[i].currency_id + '">' + currency[i].currency + '</option>');
                }
                load_saved_schedule(id);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
    $('#scheduledModal').modal('show');

}


function resetScheduleForm() {
    $('#formSchedule').trigger("reset");
}



function saveSchedule() {

    $.ajax({
        type: "POST",
        url: '/sd/blInstructionController/saveBlInstruction',
        data: {
            "token": SCHEDULED_TOKEN,
            "customer_order_id": $('#txtCustomerOrderNo').val(),
            "factory_po": $('#txtFactoryPo').val(),
            "shipping_agent_id": $('#shipping_agent').val(),
            "shipment_id": $('#shipment').val(),
            "note": $('#txtAdditionalNote').val()
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            resetScheduleForm()
        },
        success: function (response) {
            console.log(response);
            // window.location.reload();
            if (response.data.success) {
                toastr.success('Customer data has been saved successful...!');
                allVesselScheduleAttachment(UPDATE_SCHEDULED_ID);
                resetScheduleForm();
                clearDropzone();
                $("#txtCustomerOrderNo").val("");
                $("#txtFactoryPo").val("");
                $("#shipping_agent").val("");
                $("#shipment").val("");
                $("#txtAdditionalNote").val("");
                // window.location.reload();
            } else {
                if (response.data.result.errorInfo) {
                    showWarningMessage("Please make sure all fields are filled in correctly.");
                }
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {

        }

    });
}

function updateSchedule(vs_id) {
    $.ajax({
        type: "POST",
        url: "/sd/blInstructionController/update/" + vs_id,
        data: {
            "token": SCHEDULED_TOKEN,
            "customer_order_id": $('#txtCustomerOrderNo').val(),
            "factory_po": $('#txtFactoryPo').val(),
            "shipping_agent_id": $('#shipping_agent').val(),
            "shipment_id": $('#shipment').val(),
            "note": $('#txtAdditionalNote').val(),
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success("data updated");
                location.href = "/sd/blInstructionList";
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () { },
    });

}


function checkStringLength(string, maxLength) {

    if (string.length > maxLength) {
        return false;
    }
    return true;

}


function load_saved_schedule(id) {

    $.ajax({
        type: "GET",
        url: "/sd/customerOrderList/load_saved_schedule/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            resetScheduleModal();
        },
        success: function (response) {
            console.log(response);

            var result = response.data.result;

            if (result.current_schedule) {
                $('#lblScheduleFactoryOrder').text(result.factory_po_num);
                $('#lblScheduleDestination').text(result.address);
                $('#lblScheduleCustomerPo').text(result.purchase_order);
                $('#lblScheduleETA').text(result.delivery_date);
                $('#txtScheduleSuggestVessel').val(result.suggest_vessel);
                $('#txtScheduleSuggestDate').val(result.tentative_arrival_date);
                $('#txtScheduleShippingRate').val(result.shipping_rate);
                var data = [];
                for (var i = 0; i < result.attachment.length; i++) {
                    var path = "'" + result.attachment[i].file_path + "'";
                    var id = "'" + result.attachment[i].vessel_schedule_attachment_id + "'";
                    SCHEDULED_TOKEN = result.attachment[i].token;
                    $('#attachmnet_schedule_token').val(SCHEDULED_TOKEN);
                    data.push({
                        "file": result.attachment[i].description,
                        "view": '<button type= "button" class="btn btn-primary" onclick="viewScheduleAttachment(' + path + ');"><i class="fa fa-eye" aria-hidden="true"></i></button> ',
                        "download": '<button type= "button" class="btn btn-success" onclick="downloadScheduleAttachment(' + path + ');"><i class="fa fa-download" aria-hidden="true"></i></button> ',
                        "delete": '<button type= "button" class="btn btn-danger" onclick="deleteScheduleAttachment(' + id + ');"><i class="fa fa-trash" aria-hidden="true"></i></button> ',
                    });
                }
                var table = $('#tblScheduleAttachment').DataTable();
                table.clear();
                table.rows.add(data).draw();
            }


        },
        error: function (error) {
            console.log(error);

        },

    });
}


function getShipmentData() {
    $.ajax({
        type: "GET",
        url: "/sd/blInstructionController/getShipmentData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            var res = response.data.result;
            // console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#shipment").append(
                    '<option value="' +
                    res[i].shipment_id +
                    '">' +
                    res[i].shipment_no +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });
}


function getShippingAgentData() {
    $.ajax({
        type: "GET",
        url: "/sd/blInstructionController/getShippingAgentData",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            var res = response.data.result;
            // console.log(res);
            for (var i = 0; i < res.length; i++) {
                $("#shipping_agent").append(
                    '<option value="' +
                    res[i].shipping_agent_id +
                    '">' +
                    res[i].name +
                    "</option>"
                );
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () { },
    });
}


function getCustomerOrderData(id) {
    $.ajax({
        type: "GET",
        url: "/sd/blInstructionController/getCustomerOrderData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                $("#txtCustomerOrderNo").val(result[0].customer_order_id);
                $("#txtFactoryPo").val(result[0].factory_po_num);
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
        },
    });
}

function showAlert(message, id) {
    swal({
        title: message,
        text: "Once deleted, you will not be able to recover this record!",
        icon: "warning",
        buttons: true,
        dangerMode: true,
    });

    $(".swal-button--confirm").on("click", function () {
        $.ajax({
            type: "DELETE",
            url: "/sd/blInstructionController/deleteScheduleAttachment/" + id,
            data: {
                _token: $('input[name=_token]').val()
            },
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);
                if (response.data.success) {
                    showSuccessMessage("Attachment has been deleted successfully...");
                    allVesselScheduleAttachment(vs_id);
                } else {
                    showErrorMessage();
                }

            },
            error: function (error) {
                console.log(error);

            },
            complete: function () {

            }
        });
    });
}

/**
 * showSuccessMessage
 * This function is used to show success message.
 * @param message This is the paramter to require message content
 */
function showSuccessMessage(message) {
    toastr.success(message);
}

/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}

/**
 * showErrorMessage
 * This function is used to show error message.
 * @param message This is the paramter to require message content
 */
function showErrorMessage() {
    toastr.error("Something went wrong");
}
