function newID() {
    var id = undefined;
    $.ajax({
        type: "GET",
        url: '/sd/shipment/genarateExternalID',
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            id = generateID(response.shipment_id);

        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {

        }

    });

    return 'SHIP' + id;
}


/**
* generateID
* This function is used to generate id
* @param id This is the paramter to require id
*/
function generateID(id) {

    let pattern = {
        1: "0000",
        2: "000",
        3: "00",
        4: "0",
    };
    var length = Math.ceil(Math.log(id + 1) / Math.LN10);
    return pattern[length] + id;
}
